/*******************************************************************************
*****                                                                      *****
*****  This file 'R3000A.C' is an open source  interpreter, which is part  *****
*****  of our project ' PSinex PC Emulator'. The end-user is free to use  *****
*****  this file as he wishes. No responsibility  is being  taken by  the  *****
*****  authors for what may happen by applying the use of this file. Some  *****
*****  functions are not applicable, but you may create your own.          *****
*****                                                                      *****
*****  Authors: pSyChOjAk & Shunt              Monday, October 29th, 2001  *****
*****                                                                      *****
*****                                                   psinex@europe.com  *****
*****                                                                      *****
*******************************************************************************/

#define doInst() { lBFl = MemLoad32(lPCl); lPCl = lPCl + 4; TblBSC[lBFl>>26](); lGPRl[0] = 0; }
#define	Branch(PC) { uLONG lNPCl = (PC); lDOSLTl = 1; doInst(); lDOSLTl = 0; lPCl = lNPCl; }

#define lRDl ((lBFl>>11) & 31)
#define lRTl ((lBFl>>16) & 31)
#define lRSl ((lBFl>>21) & 31)

#define immS (sWORD)lBFl
#define immU (lBFl & 0xFFFF)

#define MFC 0x00
#define CFC 0x02
#define MTC 0x04
#define CTC 0x06
#define RFE 0x10

uLONG lGPRl[32], lCPRl[32], lPCl, lHIl;
uLONG lC2Cl[32], lC2Dl[32], lBFl, lLOl;

BOOL lDOSLTl;


void Ex(uLONG *PC, uLONG Ex) {
	
	lCPRl[12] = (lCPRl[12]&~0x3f) | ((lCPRl[12]<<2)&0x3f);
	lCPRl[13] = lDOSLTl ? Ex | 0x80000000 : Ex;
	lCPRl[14] = lDOSLTl ? *PC-4 : *PC;
	*PC = 0x80;
}

void r3kaUNKNOWN() { }

void r3kaSPECIAL() { TblSPC[lBFl & 63](); }
void r3kaREGIMM () { TblRGM[lRTl](); }

void r3kaADDI   () { lGPRl[lRTl] =        lGPRl[lRSl] + immS; }
void r3kaADDIU  () { lGPRl[lRTl] =        lGPRl[lRSl] + immS; }
void r3kaSLTI   () { lGPRl[lRTl] = (sLONG)lGPRl[lRSl] < immS; }
void r3kaSLTIU  () { lGPRl[lRTl] =        lGPRl[lRSl] < immU; }
void r3kaANDI   () { lGPRl[lRTl] =        lGPRl[lRSl] & immU; }
void r3kaORI    () { lGPRl[lRTl] =        lGPRl[lRSl] | immU; }
void r3kaXORI   () { lGPRl[lRTl] =        lGPRl[lRSl] ^ immU; }

void r3kaLUI    () { lGPRl[lRTl] = lBFl << 16; }

void r3kaSLL    () { lGPRl[lRDl] =        lGPRl[lRTl] << ((lBFl>>6) & 0x1F); }
void r3kaSRL    () { lGPRl[lRDl] =        lGPRl[lRTl] >> ((lBFl>>6) & 0x1F); }
void r3kaSRA    () { lGPRl[lRDl] = (sLONG)lGPRl[lRTl] >> ((lBFl>>6) & 0x1F); }

void r3kaSLLV   () { lGPRl[lRDl] =        lGPRl[lRTl] << (lGPRl[lRSl] & 0x1F); }
void r3kaSRLV   () { lGPRl[lRDl] =        lGPRl[lRTl] >> (lGPRl[lRSl] & 0x1F); }
void r3kaSRAV   () { lGPRl[lRDl] = (sLONG)lGPRl[lRTl] >> (lGPRl[lRSl] & 0x1F); }

void r3kaADD    () { lGPRl[lRDl] =        lGPRl[lRSl] +        lGPRl[lRTl] ; }
void r3kaADDU   () { lGPRl[lRDl] =        lGPRl[lRSl] +        lGPRl[lRTl] ; }
void r3kaSUB    () { lGPRl[lRDl] =        lGPRl[lRSl] -        lGPRl[lRTl] ; }
void r3kaSUBU   () { lGPRl[lRDl] =        lGPRl[lRSl] -        lGPRl[lRTl] ; }
void r3kaAND    () { lGPRl[lRDl] =        lGPRl[lRSl] &        lGPRl[lRTl] ; }
void r3kaOR     () { lGPRl[lRDl] =        lGPRl[lRSl] |        lGPRl[lRTl] ; }
void r3kaXOR    () { lGPRl[lRDl] =        lGPRl[lRSl] ^        lGPRl[lRTl] ; }
void r3kaNOR    () { lGPRl[lRDl] =      ~(lGPRl[lRSl] |        lGPRl[lRTl]); }
void r3kaSLT    () { lGPRl[lRDl] = (sLONG)lGPRl[lRSl] < (sLONG)lGPRl[lRTl] ; }
void r3kaSLTU   () { lGPRl[lRDl] =        lGPRl[lRSl] <        lGPRl[lRTl] ; }

void r3kaJ      () {                       Branch((lPCl&0xF0000000) | ((lBFl&0x3FFFFFF)<<2)); }
void r3kaJAL    () { lGPRl[31] = lPCl + 4; Branch((lPCl&0xF0000000) | ((lBFl&0x3FFFFFF)<<2)); }

void r3kaJR     () {                       Branch(lGPRl[lRSl]); }
void r3kaJALR   () { lGPRl[31] = lPCl + 4; Branch(lGPRl[lRSl]); }

void r3kaBEQ    () { if (lGPRl[lRSl] == lGPRl[lRTl]) Branch(lPCl + (immS<<2)); }
void r3kaBNE    () { if (lGPRl[lRSl] != lGPRl[lRTl]) Branch(lPCl + (immS<<2)); }

void r3kaBLEZ   () { if ((sLONG)lGPRl[lRSl] <= 0) Branch(lPCl + (immS<<2)); }
void r3kaBGTZ   () { if ((sLONG)lGPRl[lRSl] >  0) Branch(lPCl + (immS<<2)); }
void r3kaBLTZ   () { if ((sLONG)lGPRl[lRSl] <  0) Branch(lPCl + (immS<<2)); }
void r3kaBGEZ   () { if ((sLONG)lGPRl[lRSl] >= 0) Branch(lPCl + (immS<<2)); }

void r3kaBLTZAL () { lGPRl[31] = lPCl + 4; if ((sLONG)lGPRl[lRSl] <  0) Branch(lPCl + (immS<<2)); }
void r3kaBGEZAL () { lGPRl[31] = lPCl + 4; if ((sLONG)lGPRl[lRSl] >= 0) Branch(lPCl + (immS<<2)); }

void r3kaCOP0   () { switch (lRSl) {

					 case MFC: lGPRl[lRTl] = lCPRl[lRDl]; break;
					 case MTC: lCPRl[lRDl] = lGPRl[lRTl]; break;
					 
					 case RFE: lCPRl[12] = (lCPRl[12]&~0xF) | ((lCPRl[12]>>2)&0xF); break; }
}

void r3kaCOP2   () { switch (lRSl) {

					 case MFC: lGPRl[lRTl] = lC2Dl[lRDl]; break;
					 case CFC: lGPRl[lRTl] = lC2Dl[lRDl]; break;
					 case MTC: lC2Dl[lRDl] = lGPRl[lRTl]; break;
					 case CTC: lC2Dl[lRDl] = lGPRl[lRTl]; break; }
}

void r3kaLB     () { lGPRl[lRTl] = (sBYTE)MemLoad08(lGPRl[lRSl] + immS); }
void r3kaLBU    () { lGPRl[lRTl] = (uBYTE)MemLoad08(lGPRl[lRSl] + immS); }
void r3kaLH     () { lGPRl[lRTl] = (sWORD)MemLoad16(lGPRl[lRSl] + immS); }
void r3kaLHU    () { lGPRl[lRTl] = (uWORD)MemLoad16(lGPRl[lRSl] + immS); }
void r3kaLW     () { lGPRl[lRTl] = (uLONG)MemLoad32(lGPRl[lRSl] + immS); }

void r3kaLWL    () { uLONG addr = lGPRl[lRSl] + immS, data = MemLoad32(addr&~3);

					 switch (addr & 3) {
					 
					 case 3: lGPRl[lRTl] = data; break;
					 
					 case 2: lGPRl[lRTl] = (lGPRl[lRTl]&0x000000FF) | (data<< 8); break;
					 case 1: lGPRl[lRTl] = (lGPRl[lRTl]&0x0000FFFF) | (data<<16); break;
					 case 0: lGPRl[lRTl] = (lGPRl[lRTl]&0x00FFFFFF) | (data<<24); break; }
}

void r3kaLWR    () { uLONG addr = lGPRl[lRSl] + immS, data = MemLoad32(addr&~3);

					 switch (addr & 3) {
					 
					 case 0: lGPRl[lRTl] = data; break;
					 
					 case 1: lGPRl[lRTl] = (lGPRl[lRTl]&0xFF000000) | (data>> 8); break;
					 case 2: lGPRl[lRTl] = (lGPRl[lRTl]&0xFFFF0000) | (data>>16); break;
					 case 3: lGPRl[lRTl] = (lGPRl[lRTl]&0xFFFFFF00) | (data>>24); break; }
}

void r3kaSB     () { MemSave08(lGPRl[lRSl] + immS, (uBYTE)lGPRl[lRTl]); }
void r3kaSH     () { MemSave16(lGPRl[lRSl] + immS, (uWORD)lGPRl[lRTl]); }
void r3kaSW     () { MemSave32(lGPRl[lRSl] + immS, (uLONG)lGPRl[lRTl]); }

void r3kaSWL    () { uLONG addr = lGPRl[lRSl] + immS, data = MemLoad32(addr&~3);

					 switch (addr & 3) {
					 
					 case 3: data = lGPRl[lRTl]; break;

					 case 2: data = (data&0xFF000000) | (lGPRl[lRTl]>> 8); break;
					 case 1: data = (data&0xFFFF0000) | (lGPRl[lRTl]>>16); break;
					 case 0: data = (data&0xFFFFFF00) | (lGPRl[lRTl]>>24); break; }
					 
					 MemSave32(addr&~3, data);
}

void r3kaSWR    () { uLONG addr = lGPRl[lRSl] + immS, data = MemLoad32(addr&~3);

					 switch (addr & 3) {
					 
					 case 0: data = lGPRl[lRTl]; break;

					 case 1: data = (data&0x000000FF) | (lGPRl[lRTl]<< 8); break;
					 case 2: data = (data&0x0000FFFF) | (lGPRl[lRTl]<<16); break;
					 case 3: data = (data&0x00FFFFFF) | (lGPRl[lRTl]<<24); break; }
					 
					 MemSave32(addr&~3, data);
}

void r3kaLWC2   () { lC2Dl[lRTl] = MemLoad32(lGPRl[lRSl] + immS); }

void r3kaSWC2   () { MemSave32(lGPRl[lRSl] + immS, lC2Dl[lRTl]); }

void r3kaSYSCALL() { lPCl = lPCl - 4; Ex(&lPCl, 0x20); }

void r3kaBREAK  () { }

void r3kaMFHI   () { lGPRl[lRDl] = lHIl; }
void r3kaMTHI   () { lHIl = lGPRl[lRSl]; }
void r3kaMFLO   () { lGPRl[lRDl] = lLOl; }
void r3kaMTLO   () { lLOl = lGPRl[lRSl]; }

void r3kaMULT   () { uLONG M1 = (sLONG)lGPRl[lRSl], M2 = (sLONG)lGPRl[lRTl];
					 
					 __asm { mov  eax , M1
							 mov  ebx , M2
							 imul ebx
							 mov  lLOl, eax
							 mov  lHIl, edx }
}

void r3kaMULTU  () { uLONG M1 = (sLONG)lGPRl[lRSl], M2 = (sLONG)lGPRl[lRTl];
					 
					 __asm { mov  eax , M1
							 mov  ebx , M2
							 mul  ebx
							 mov  lLOl, eax
							 mov  lHIl, edx }
}

void r3kaDIV    () { if (lGPRl[lRTl]) {
	
					 lLOl = (sLONG)lGPRl[lRSl] / (sLONG)lGPRl[lRTl];
					 lHIl = (sLONG)lGPRl[lRSl] % (sLONG)lGPRl[lRTl]; } else {
						 
					 lLOl = (sLONG)0;
					 lHIl = (sLONG)0; }
}

void r3kaDIVU   () { if (lGPRl[lRTl]) {
	
					 lLOl = (uLONG)lGPRl[lRSl] / (uLONG)lGPRl[lRTl];
					 lHIl = (uLONG)lGPRl[lRSl] % (uLONG)lGPRl[lRTl]; } else {
						 
					 lLOl = (uLONG)0;
					 lHIl = (uLONG)0; }
}

void (*TblBSC[64])() = {

	r3kaSPECIAL, r3kaREGIMM, r3kaJ, r3kaJAL, r3kaBEQ, r3kaBNE, r3kaBLEZ, r3kaBGTZ,
	r3kaADDI, r3kaADDIU, r3kaSLTI, r3kaSLTIU, r3kaANDI, r3kaORI, r3kaXORI, r3kaLUI,
	r3kaCOP0, r3kaUNKNOWN, r3kaCOP2, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN,
	r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN,
	r3kaLB, r3kaLH, r3kaLWL, r3kaLW, r3kaLBU, r3kaLHU, r3kaLWR, r3kaUNKNOWN,
	r3kaSB, r3kaSH, r3kaSWL, r3kaSW, r3kaUNKNOWN, r3kaUNKNOWN, r3kaSWR, r3kaUNKNOWN,
	r3kaUNKNOWN, r3kaUNKNOWN, r3kaLWC2, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN,
	r3kaUNKNOWN, r3kaUNKNOWN, r3kaSWC2, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN
};

void (*TblSPC[64])() = {

	r3kaSLL, r3kaUNKNOWN, r3kaSRL, r3kaSRA, r3kaSLLV, r3kaUNKNOWN, r3kaSRLV, r3kaSRAV,
	r3kaJR, r3kaJALR, r3kaUNKNOWN, r3kaUNKNOWN, r3kaSYSCALL, r3kaBREAK, r3kaUNKNOWN, r3kaUNKNOWN,
	r3kaMFHI, r3kaMTHI, r3kaMFLO, r3kaMTLO, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN,
	r3kaMULT, r3kaMULTU, r3kaDIV, r3kaDIVU, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN,
	r3kaADD, r3kaADDU, r3kaSUB, r3kaSUBU, r3kaAND, r3kaOR, r3kaXOR, r3kaNOR,
	r3kaUNKNOWN, r3kaUNKNOWN, r3kaSLT, r3kaSLTU, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN,
	r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN
};

void (*TblRGM[32])() = {

	r3kaBLTZ, r3kaBGEZ, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN,
	r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN,
	r3kaBLTZAL, r3kaBGEZAL, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN,
	r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN, r3kaUNKNOWN
};